/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * This is GNU GO, a Go program. Contact gnugo@gnu.org, or see   *
 * http://www.gnu.org/software/gnugo/ for more information.      *
 *                                                               *
 * Copyright 1999 by the Free Software Foundation.               *
 *                                                               *
 * This program is free software; you can redistribute it and/or *
 * modify it under the terms of the GNU General Public License   *
 * as published by the Free Software Foundation - version 2.     *
 *                                                               *
 * This program is distributed in the hope that it will be       *
 * useful, but WITHOUT ANY WARRANTY; without even the implied    *
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR       *
 * PURPOSE.  See the GNU General Public License in file COPYING  *
 * for more details.                                             *
 *                                                               *
 * You should have received a copy of the GNU General Public     *
 * License along with this program; if not, write to the Free    *
 * Software Foundation, Inc., 59 Temple Place - Suite 330,       *
 * Boston, MA 02111, USA                                         *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */




#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>

#include "liberty.h"

/* Extra damping coefficient for spreading influence diagonally. */
#define DIAGONAL_DAMPING 2.0

/* Default strength of the influence from a stone. May be lowered if
 * it is unsafe.
 */
#define DEFAULT_STRENGTH 100.0

/* Smallest amount of influence that we care about distributing. */
/*#define INFLUENCE_CUTOFF 0.02*/
#define INFLUENCE_CUTOFF 0.0

/* Value in delta_territory_cache indicating that the value has not
 * been computed. Arbitrary but unattainable.
 */
#define NOT_COMPUTED (-2 * MAX_BOARD * MAX_BOARD)

struct influence_data
{
  float white_influence[MAX_BOARD][MAX_BOARD]; /* Accumulated influence. */
  float black_influence[MAX_BOARD][MAX_BOARD]; /* Accumulated influence. */
  int p[MAX_BOARD][MAX_BOARD];           /* Working copy of board array. */
  float strength[MAX_BOARD][MAX_BOARD];  /* Strength of influence source. */
  int color[MAX_BOARD][MAX_BOARD];       /* Color of influence source,    */
					 /* EMPTY, WHITE, BLACK, or both. */
  float south_attenuation[MAX_BOARD][MAX_BOARD]; /* Attenuation in */
  float west_attenuation[MAX_BOARD][MAX_BOARD];  /* different      */
  float north_attenuation[MAX_BOARD][MAX_BOARD]; /* directions.    */
  float east_attenuation[MAX_BOARD][MAX_BOARD];
  float white_permeability[MAX_BOARD][MAX_BOARD];
  float black_permeability[MAX_BOARD][MAX_BOARD];
  
  float w[MAX_BOARD][MAX_BOARD];         /* Working area. */
  int queuei[MAX_BOARD * MAX_BOARD];     /* Points receiving influence. */
  int queuej[MAX_BOARD * MAX_BOARD];
};

/*
 * Local Variables:
 * tab-width: 8
 * c-basic-offset: 2
 * End:
 */
